% 
% COMPUTER INTEGRATED SURGERY, 600.446, Group 4
% Quantitative Assessment of Metal Artifact Reduction in C-arm Cone-Beam CT
% Guidance of Neurovascular Interventions
%
% SCRIPT spheres_volume.m : calculates the volume of each density 
% metal sphere in each size in the first constructed brain phantom. 
% Analysis is run on both the uncorrected and MAR corrected images.
%
% 
% Authors: Marta Wells <mwells20@jhu.edu> 
%          Carolina Cay-Martinez <ccaymar1@jhu.edu>
%          
% 
% Johns Hopkins University
% May 2013
%
%------------------------------------------------------------------------

clear all

fdmar = ['C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Corrected\MAR_[CORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL_US_0016';  
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Corrected\MAR_[CORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL_US_0020';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Corrected\MAR_[CORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL_US_0022';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Corrected\MAR_[CORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL_US_0014';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Corrected\MAR_[CORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL_US_0017';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Corrected\MAR_[CORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL_US_0021';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Corrected\MAR_[CORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL_US_0015'
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Corrected\MAR_[CORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL_US_0019';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Corrected\MAR_[CORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL_US_X020'];

fdnon = ['C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Uncorrected\MAR_[UNCORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL__0016';  
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Uncorrected\MAR_[UNCORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL__0020';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Uncorrected\MAR_[UNCORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL__0022';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Uncorrected\MAR_[UNCORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL__0014';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Uncorrected\MAR_[UNCORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL__0017';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Uncorrected\MAR_[UNCORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL__0021';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Uncorrected\MAR_[UNCORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL__0015'
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Uncorrected\MAR_[UNCORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL__0019';
'C:\Users\mwells20\Documents\2012-2013\Spring 2013\CIS2\Spheres - Leo MAR\Uncorrected\MAR_[UNCORRECTED]_DT_NON-S_NAT_FILL_HU_NORMAL_[NO_CLINICAL__X020'];

%% 1. 16 - 3.2mm Titanium
%% 2. 20 - 6.4mm Titanium
%% 3. 22 - 12.8mm Titanium
%% 4. 14 - 3.2mm Steel
%% 5. 17 - 6.4mm Steel
%% 6. 21 - 12.8mm Steel
%% 7. 15 - 3.2mm Tungsten
%% 8. 19 - 6.4mm Tungsten
%% 9. 20x - 12.8mm Tungsten

num = length(fdmar(:,1));

[yy xx] = meshgrid(1:512);

centers = [277,233;
    292,228;
    285,231;
    295,229;
    289,229;
    292,229;
    296,218;
    288,233;
    357,242];

fst = [150;
    165;
    148;
    159;
    150;
    160;
    171;
    157;
    241];

maskrad = [10,13,20,10,13,23,10,13,23];  %%% Inner Radius - 3
depth = [9,15,27,10,16,32,9,18,43];

threshold = 5000;
voxelarea = 0.5*0.5*0.5;

volume = zeros(3,num);
volume(3,:) = [(4/3)*pi*(3.2/2)^3;(4/3)*pi*(6.4/2)^3;(4/3)*pi*(12.8/2)^3;
                (4/3)*pi*(3.2/2)^3;(4/3)*pi*(6.4/2)^3;(4/3)*pi*(12.8/2)^3;
                (4/3)*pi*(3.2/2)^3;(4/3)*pi*(6.4/2)^3;(4/3)*pi*(12.8/2)^3;];
            
th = linspace(0,2*pi,100);
    
for i = 1:num
    center = centers(i,:);
    findex = fst(i,:);
    
    centermask = sqrt((xx-center(1)).^2+(yy-center(2)).^2)<=maskrad(i);
    
    for j = 1:depth(i)
        if (i == 6 && j > 10)
            centermask = sqrt((xx-center(1)).^2+(yy-center(2)).^2)<=(maskrad(i)+2);
        end
        
        cd(char(fdmar(i,:)));
        ss = ls;
        mar{j} = int16(dicomread(char(ss(findex(1)+1+j,:))))-1024;
        cd(char(fdnon(i,:)));
        tt = ls;
        non{j} = int16(dicomread(char(tt(findex(1)+1+j,:))))-1024;
        centercircmar = mar{j}(centermask);
        volume(1,i) = volume(1,i) + length(find(centercircmar>=threshold));
        centercircnon = non{j}(centermask);
        volume(2,i) = volume(2,i)+length(find(centercircnon>=threshold));
        
        %%% PLOT CHECK
%         figure;
%         imshow(non{j},'DisplayRange',[-1024 4500-1024])
%         hold on
%         if (i == 6 && j > 10)
%             x = -(maskrad(i)+2)*cos(th) + center(2);
%             y = -(maskrad(i)+2)*sin(th) + center(1);
%         else
%             x = -maskrad(i)*cos(th) + center(2);
%             y = -maskrad(i)*sin(th) + center(1);
%         end
%         plot(x,y); axis equal;

    end
    
    volume(1:2,i) = volume(1:2,i)*voxelarea;
end

cd ../../

























